using DiskAccessLibrary;
using System;
using System.Windows.Forms;
using DiskAccessLibrary.Mod;

namespace ISCSIConsole
{
    public partial class CreateRAMDiskForm : Form
    {
        private Disk m_ramDisk;

        public CreateRAMDiskForm()
        {
            InitializeComponent();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            if (MbRadioButton.Checked)
            {
                var size = (int)numericDiskSize.Value * 1024 * 1024;
                RAMDisk disk;
                try
                {
                    disk = new RAMDisk(size);
                }
                catch (OutOfMemoryException)
                {
                    MessageBox.Show("Not enough memory available", "Error");
                    return;
                }
                m_ramDisk = disk;
            }
            else if (GbRadioButton.Checked)
            {
                var size = (int)numericDiskSize.Value;
                UnmanagedLargeRamDisk disk = new UnmanagedLargeRamDisk(size); ;
                try
                {
                    disk.Allocate();
                }
                catch (OutOfMemoryException)
                {
                    disk.Free();
                    MessageBox.Show("Not enough memory available", "Error");
                    return;
                }
                m_ramDisk = disk;
            }
            else
            {
                MessageBox.Show("What chosen?");
                return;
            }
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        public Disk RAMDisk
        {
            get
            {
                return m_ramDisk;
            }
        }
    }
}